/*

Copyright (C) 2012  Observatoire de Paris

The JavaScript code in this page is free software: you can
redistribute it and/or modify it under the terms of the GNU
General Public License (GNU GPL) as published by the Free Software
Foundation, either version 3 of the License, or (at your option)
any later version.  The code is distributed WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU GPL for more details.

As additional permission under GNU GPL version 3 section 7, you
may distribute non-source (e.g., minimized or compacted) forms of
that code without the copy of the GNU GPL normally required by
section 4, provided you include this license notice and a URL
through which recipients can access the Corresponding Source.

*/

var image;
var canvas;
var context;
var canvastrace;
var ctxtrace;
var zones;
var zonesel;
/*
var initWidth = 300;
var initHeight = 300;
*/

if (!window.Node) {
    var Node =
    {
        ELEMENT_NODE                :  1,
        ATTRIBUTE_NODE              :  2,
        TEXT_NODE                   :  3,
        CDATA_SECTION_NODE          :  4,
        ENTITY_REFERENCE_NODE       :  5,
        ENTITY_NODE                 :  6,
        PROCESSING_INSTRUCTION_NODE :  7,
        COMMENT_NODE                :  8,
        DOCUMENT_NODE               :  9,
        DOCUMENT_TYPE_NODE          : 10,
        DOCUMENT_FRAGMENT_NODE      : 11,
        NOTATION_NODE               : 12
    };
}

function lireParametres() {
    var parametres = new Array();
    var searchString = window.location.search.substring(1);
    var params = searchString.split("&");
    
    for (var i=0; i<params.length; i++) {
        var nomval = params[i].split("=");
        // remarque: les paramètres de l'URL doivent être encodés en UNICODE
        parametres[nomval[0]] = decodeURIComponent(nomval[1]);
    }
    return(parametres);
}

function init() {
    var parametres = lireParametres();
    var chemin_image = parametres['image'];
    var chemin_fichiers = parametres['chemin_fichiers'];
    if (chemin_fichiers != null)
        chemin_image = chemin_fichiers + chemin_image;
    
    // lecture de nomimage.carte
    var xmldoc;
    var fcarte = parametres['fcarte'];
    if (fcarte == null) {
        fcarte = chemin_image;
        if (fcarte.indexOf('.') != -1)
            fcarte = fcarte.substring(0, fcarte.lastIndexOf('.')) + '.carte';
    } else if (chemin_fichiers != null)
        fcarte = chemin_fichiers + fcarte;
    xmldoc = chargementXML(fcarte); // pb du type MIME (doit être text/xml !)
    if (xmldoc == null) {
        alert('fichier introuvable: ' + fcarte);
        return;
    }
    var carte = xmldoc.documentElement;
    if (carte == null) {
        alert('Erreur au chargement du fichier XML');
        return;
    }
    if (carte.nodeName.toUpperCase() != 'CARTE')
        alert('Mauvais fichier XML (la racine est ' + carte.nodeName + ' au lieu de CARTE)');
    /*
    var sInitWidth = carte.getAttribute('largeur');
    var sInitHeight = carte.getAttribute('hauteur');
    if (sInitWidth != null && sInitWidth != '' && sInitHeight != null && sInitHeight != '') {
        initWidth = Number(sInitWidth);
        initHeight = Number(sInitHeight);
        if (isNaN(initWidth) || isNaN(initHeight))
            alert("Erreur dans le formattage des dimensions de l'image: " + sInitWidth + 'x' + initHeight);
    }
    */
    zones = new Array();
    var ztree;
    var i=0;
    for (ztree=carte.firstChild; ztree!=null; ztree=ztree.nextSibling)
        if (ztree.nodeType == Node.ELEMENT_NODE)
            zones[i++] = new Zone(ztree);
    zonesel = -1;
    var lab = document.getElementById('legende');
    lab.value = 'préparation...';
    
    image = new Image();
    //image.onload = premierAffichage;
    // ne marche pas avec IE9: drawImage ne marche pas toujours après, même si complete=true !
    image.onload = function() {
        if (navigator.appName == 'Microsoft Internet Explorer')
            setTimeout(premierAffichage, 250);
        else
            premierAffichage();
    };
    image.onerror = function(err) { alert("Erreur au chargement de l'image " + chemin_image) };
    image.src = chemin_image;
}

function chargementXML(fichierXML) {
    var xmlhttp;
    if (window.XMLHttpRequest) {
        // IE7+, Firefox, Chrome, Opera, Safari
        xmlhttp = new XMLHttpRequest();
    } else {
        // IE6, IE5
        xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
    }
    xmlhttp.open("GET", fichierXML, false);
    if (xmlhttp.overrideMimeType) // inconnu de IE
        xmlhttp.overrideMimeType('text/xml');
    try {
        xmlhttp.send();
        // comme overrideMimeType ne marche pas avec IE, xmlhttp.getResponseHeader('Content-Type') renvoie text/plain
        // et la réponse est seulement disponible sous forme de texte
        if (xmlhttp.responseXML != null && xmlhttp.responseXML.documentElement == null && xmlhttp.responseText != null) {
            // pour IE
            alert('Le fichier ' + fichierXML + ' ne peut être lu correctement parce-que le serveur utilise un mauvais type MIME (' + xmlhttp.getResponseHeader('Content-Type') + '), et le navigateur ne peut pas le modifier');
            
            // aucune des 2 instructions suivantes ne fonctionne, à cause d'un pb d'encodage :
            //xmlhttp.responseXML.loadXML(xmlhttp.responseText);
            //return(parseXML(xmlhttp.responseText));
            
            // tentative de suppression des caractères spéciaux (ne marche pas en général)
            var xmltxt = xmlhttp.responseText.replace(/[^<>=\-.,\|\/\?"a-zA-Z\s0-9]+/g,'');
            return(parseXML(xmltxt));
        }
    } catch (ex) {
        alert(ex.description);
        return(null);
    }
    return(xmlhttp.responseXML);
}

function parseXML(txt) {
    if (window.DOMParser) {
        parser = new DOMParser();
        xmlDoc = parser.parseFromString(txt, 'text/xml');
    } else {
        // pour IE7 et IE8
        xmlDoc = new ActiveXObject('Microsoft.XMLDOM'); // ou 'MSXML.DomDocument' ?
        xmlDoc.async = false;
        xmlDoc.loadXML(txt);
    }
    return(xmlDoc);
}

function premierAffichage() {
    var divimage = document.getElementById('divimage');
    divimage.style.width = image.width + 'px';
    canvas = document.createElement('canvas');
    // parfois les dimensions données dans le fichier .carte sont inférieures à celles de l'image !
    // du coup on utilise image.width et image.height au lieu de initWidth et initHeight
    canvas.setAttribute('width', image.width);
    canvas.setAttribute('height', image.height);
    divimage.appendChild(canvas);
    if (typeof G_vmlCanvasManager  != 'undefined' ) {
        G_vmlCanvasManager.initElement(canvas);
    }
    
    if (!canvas.getContext) {
        divimage.innerHTML = '<p>Votre navigateur ne gère pas HTML5.</p>';
        return;
    }
    
    context = canvas.getContext('2d');
    // les bitmaps offscreen sont impossibles avec excanvas et flashcanvas
    // pour que ça marche avec IE7 et IE8, on utilise un autre élément canvas
    // pour tracer les lignes et les cercles
    canvastrace = document.createElement('canvas');
    canvastrace.setAttribute('width', image.width);
    canvastrace.setAttribute('height', image.height);
    // setAttribute ne marche pas pour style avec IE...
    canvastrace.style.position = 'absolute';
    canvastrace.style.left = '0px';
    canvastrace.style.top = '0px';
    divimage.appendChild(canvastrace);
    if (typeof G_vmlCanvasManager  != 'undefined' ) {
        canvastrace = G_vmlCanvasManager.initElement(canvastrace);
    }
    ctxtrace = canvastrace.getContext('2d');
    ctxtrace.globalAlpha = 0.3;
    ctxtrace.fillStyle = '#00FFFF';
    
    if (canvastrace.addEventListener)
        canvastrace.addEventListener('mousemove', mousemove, false);
    else
        canvastrace.attachEvent('onmousemove', mousemove);
    if ('ontouchstart' in document) {
        canvastrace.addEventListener('touchstart', mousemove, false);
        canvastrace.addEventListener('touchmove', mousemove, false);
    }
    
    context.drawImage(image, 0, 0);
    
    // ajout du rectangle rouge sur l'image de départ
    context.fillStyle = 'rgba(255, 0, 0, 0.5)';
    context.fillRect(0, 0, 20, 20);
    
    var lab = document.getElementById('legende');
    lab.value = 'Déplacer le curseur sur la carte pour activer certaines zones. Le coin rouge permet de voir toutes les zones.';
}

function coordonnees(e) {
    // résultat décalé de 1px avec excanvas :(
    var x, y;
    if (e.pageX || e.pageY) {
      x = e.pageX;
      y = e.pageY;
    } else {
      x = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
      y = e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
    }
    var totalOffsetX = 0;
    var totalOffsetY = 0;
    var currentElement = canvastrace;
    do {
        totalOffsetX += currentElement.offsetLeft;
        totalOffsetY += currentElement.offsetTop;
    } while (currentElement = currentElement.offsetParent)
    x -= totalOffsetX;
    y -= totalOffsetY;
    return( { x : x, y : y } );
}

function mousemove(e) {
    var pt = coordonnees(e);
    var trouve = false;
    for (var i=0; i<zones.length; i++)
        if (zones[i].contains(pt.x,pt.y)) {
            if (zonesel != i) {
                var st = zones[i].getTexte();
                var lab = document.getElementById('legende');
                lab.value = st;
                effacer();
                zones[i].dessiner(ctxtrace);
                zonesel = i;
            }
            trouve = true;
            break;
        }
    if (!trouve && pt.x < 20 && pt.y < 20) {
        effacer();
        for (var i=0; i<zones.length; i++)
            zones[i].dessiner(ctxtrace);
        if (zonesel != -1) {
            var lab = document.getElementById('legende');
            lab.value = '';
            zonesel = -1;
        }
    } else if (!trouve && zonesel != -1) {
        var lab = document.getElementById('legende');
        lab.value = '';
        effacer();
        zonesel = -1;
    }
    if (e.preventDefault)
        e.preventDefault();
    else
        e.returnValue = false;
}

function effacer() {
    ctxtrace.clearRect(0, 0, canvastrace.width, canvastrace.height);
}

function Zone(zonetree) {
    this.texte = zonetree.getAttribute('texte');
    this.souszones = new Array();
    var sztree;
    var i=0;
    for (sztree=zonetree.firstChild; sztree!=null; sztree=sztree.nextSibling) {
        if (sztree.nodeType == Node.ELEMENT_NODE) {
            var sforme = sztree.getAttribute('forme');
            var coords = sztree.getAttribute('coords');
            this.souszones[i++] = new SousZone(sforme, coords);
        }
    }
    this.image = null;
    return(this);
}
Zone.prototype.contains = function(x, y) {
    for (var i=0; i<this.souszones.length; i++)
        if (this.souszones[i].contains(x,y))
            return(true);
    return(false);
}
Zone.prototype.getTexte = function() {
    return(this.texte);
}
Zone.prototype.dessiner = function(ctx) {
    for (var i=0; i<this.souszones.length; i++)
        this.souszones[i].dessiner(ctx);
}

function SousZone(sforme, coords) {
    this.forme = null;
    
    if (sforme == 'polygone') {
        this.forme = new Polygone();
        var sc = coords;
        while (sc.indexOf(',') != -1) {
            var iv = sc.indexOf(',');
            var sx = sc.substring(0,iv);
            sc = sc.substring(iv+1);
            iv = sc.indexOf(',');
            var sy;
            if (iv != -1) {
                sy = sc.substring(0,iv);
                sc = sc.substring(iv+1);
            } else {
                sy = sc;
                sc = '';
            }
            var x = Number(sx);
            var y = Number(sy);
            if (isNaN(x) || isNaN(y))
                alert('mauvais format pour les coordonnées: ' + coords);
            this.forme.ajouterPoint(x, y);
        }
    } else if (sforme == 'rectangle') {
        var sc = coords;
        var sx1=null,sy1=null,sx2=null,sy2=null;
        var iv = sc.indexOf(',');
        if (iv != -1) {
            sx1 = sc.substring(0,iv);
            sc = sc.substring(iv+1);
            iv = sc.indexOf(',');
        }
        if (iv != -1) {
            sy1 = sc.substring(0,iv);
            sc = sc.substring(iv+1);
            iv = sc.indexOf(',');
        }
        if (iv != -1) {
            sx2 = sc.substring(0,iv);
            sc = sc.substring(iv+1);
            iv = sc.indexOf(',');
        }
        if (iv == -1)
            sy2 = sc;
        if (sx1 != null && sy1 != null && sx2 != null && sy2 != null) {
            var x1 = Number(sx1);
            var y1 = Number(sy1);
            var x2 = Number(sx2);
            var y2 = Number(sy2);
            if (isNaN(x1) || isNaN(y1) || isNaN(x2) || isNaN(y2))
                alert('mauvais format pour les coordonnées: ' + coords);
            this.forme = new Rectangle(x1, y1, x2-x1, y2-y1);
        }
    } else if (sforme == 'cercle') {
        var sc = coords;
        var sx=null,sy=null,sr=null;
        var iv = sc.indexOf(',');
        if (iv != -1) {
            sx = sc.substring(0,iv);
            sc = sc.substring(iv+1);
            iv = sc.indexOf(',');
        }
        if (iv != -1) {
            sy = sc.substring(0,iv);
            sc = sc.substring(iv+1);
            iv = sc.indexOf(',');
        }
        if (iv == -1)
            sr = sc;
        if (sx != null && sy != null && sr != null) {
            var x = Number(sx);
            var y = Number(sy);
            var r = Number(sr);
            if (isNaN(x) || isNaN(y) || isNaN(r))
                alert('mauvais format pour les coordonnées: ' + coords);
            this.forme = new Cercle(x, y, r);
        }
    }
}
SousZone.prototype.contains = function(x, y) {
    if (this.forme != null)
        return(this.forme.contains(x, y));
    else
        return(false);
}
SousZone.prototype.dessiner = function(ctx) {
    if (this.forme != null)
        this.forme.dessiner(ctx);
}

function Point(x, y) {
    this.x = x;
    this.y = y;
    return(this);
}

function Rectangle(x, y, width, height) {
    this.x = x;
    this.y = y;
    this.width = width;
    this.height = height;
}
Rectangle.prototype.contains = function(x, y) {
    var x2 = this.x + this.width - 1;
    var y2 = this.y + this.height - 1;
    return(x >= this.x && x <= x2 && y >= this.y && y <= y2);
}
Rectangle.prototype.dessiner = function(ctx) {
    ctx.fillRect(this.x, this.y, this.width, this.height);
}

function Polygone() {
    this.points = new Array();
}
Polygone.prototype.ajouterPoint = function(x, y) {
    this.points.push(new Point(x, y));
}
Polygone.prototype.contains = function(x, y) {
    var ctx = ctxtrace;
    ctx.beginPath();
    var p = this.points[0];
    ctx.moveTo(p.x, p.y);
    for (var i=1; i<this.points.length; i++)
        ctx.lineTo(this.points[i].x, this.points[i].y);
    if (ctx.isPointInPath)
        return(ctx.isPointInPath(x, y));
    else // isPointInPath n'existe pas dans excanvas
        return(this.pnpoly(x, y));
}
Polygone.prototype.pnpoly = function(x, y) {
    var c = false;
    for (var i=0; i<this.points.length; i++) {
        var j = (i + 1) % this.points.length;
        var xi = this.points[i].x;
        var yi = this.points[i].y;
        var xj = this.points[j].x;
        var yj = this.points[j].y;
        if ( ( (yi <= y && y < yj) || (yj <= y && y < yi) ) && (x < (xj-xi)*(y-yi)/(yj-yi) + xi) ) {
            c = !c;
        }
    }
    return(c);
}
Polygone.prototype.dessiner = function(ctx) {
    ctx.beginPath();
    var p = this.points[0];
    ctx.moveTo(p.x, p.y);
    for (var i=1; i<this.points.length; i++)
        ctx.lineTo(this.points[i].x, this.points[i].y);
    ctx.fill();
}

function Cercle(x, y, r) {
    this.cx = x;
    this.cy = y;
    this.cr = r;
}
Cercle.prototype.contains = function(x, y) {
    var x2 = x - this.cx;
    var y2 = y - this.cy;
    var d = Math.sqrt(x2*x2 + y2*y2);
    return(d < this.cr);
}
Cercle.prototype.dessiner = function(ctx) {
    ctx.beginPath();
    ctx.arc(this.cx, this.cy, this.cr, 0, 2*Math.PI, false);
    ctx.fill();
}

